stages:
  - test
  - build
  - deploy
django tests:
  stage: test
  image: python:alpine
  script:
    - pip3 install -r requirements.txt
    - mkdir db
    - python3 manage.py migrate
    - python3 manage.py test
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_REF_NAME != "main"
    - when: never

docker build:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
    - if [[ $CI_COMMIT_REF_SLUG == "main" ]]; then 
         docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} ${CI_REGISTRY_IMAGE}:latest; fi
    - if [[ $CI_COMMIT_REF_SLUG == "main" ]]; then
         docker push ${CI_REGISTRY_IMAGE}:latest; fi
  tags:
    - docker
  needs: ["django tests"]
  rules:
    - if: $CI_COMMIT_REF_NAME != "main"
    - when: never

docker release:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker pull ${CI_REGISTRY_IMAGE}:dev
    - docker tag ${CI_REGISTRY_IMAGE}:dev ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_REF_NAME != "main"



ansible build:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG} ./ansimg
    - docker push ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG}

  tags:
    - docker
  rules:
    - if: $CI_COMMIT_REF_NAME != "main"



deploy to dev:
  stage: deploy
  image: ${CI_REGISTRY_IMAGE}/ansible:${CI_COMMIT_REF_SLUG}
  before_script:
    - export ANSIBLE_CONFIG=.cicd/ansible.cfg
    - chmod 600 ${SSH_PK}
    - export ANSIBLE_HOST_KEY_CHECKING=False
    
  script:
    - cd .cicd
    - export ANSIBLE_CONFIG=./ansible.cfg
    - ansible-playbook -u ansible --private-key ${SSH_PK} -i inventories/dev/hosts playbook.yml -D

  tags:
    - docker
  rules:
    - if: $CI_COMMIT_REF_NAME != "main"
    - when: never
